SystemOrganization addCategory: #Poo!

Object subclass: #BancoDeDados
	instanceVariableNames: 'cursos usuarios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!BancoDeDados methodsFor: 'adicionando' stamp: 'tgn 5/12/2013 17:21'!
adicionaCurso: curso
	
	^cursos add: curso! !

!BancoDeDados methodsFor: 'adicionando' stamp: 'FA 5/12/2013 13:33'!
adicionaUsuario: usuario

	^usuarios add: (usuario login), '#',(usuario senha) -> usuario! !

!BancoDeDados methodsFor: 'acessando' stamp: 'tgn 5/12/2013 17:22'!
curso
	^ cursos! !

!BancoDeDados methodsFor: 'acessando' stamp: 'tgn 5/12/2013 17:21'!
devolveCursosDeNome: nome 

	| res |
	res := Set new.
	cursos do: [ :curso  |  ((curso nome) = nome) 
		                               ifTrue: [ res add: curso ] ].
	^ res	 
	! !

!BancoDeDados methodsFor: 'acessando' stamp: 'FA 5/12/2013 16:27'!
devolveUsuarioDeLogin: login ESenha: senha

	[ ^ usuarios at: (login,'#',senha) ]
	on: Exception
	do: [ ^ nil. ]	 
	! !

!BancoDeDados methodsFor: 'acessando' stamp: 'FA 5/12/2013 17:43'!
devolveUsuarioDeLogin: login eSenha: senha

	[ ^ usuarios at: (login,'#',senha) ]
	on: Exception
	do: [ ^ nil. ]	 
	! !

!BancoDeDados methodsFor: 'inicializando' stamp: 'tgn 5/12/2013 17:22'!
initialize
	cursos := Set new.
	usuarios := Dictionary new.
	^self! !

!BancoDeDados methodsFor: 'acessando' stamp: 'FA 5/12/2013 16:28'!
usuarios
	^ usuarios! !

Object subclass: #Conteudo
	instanceVariableNames: 'texto listaDeNotas listaDeNotasModerador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Conteudo methodsFor: 'primitivas' stamp: 'tgn 5/12/2013 17:05'!
adicionaNota: nota
	"Adiciona nota para esse conteudo"
	
	listaDeNotas add: nota! !

!Conteudo methodsFor: 'primitivas' stamp: 'tgn 5/12/2013 17:05'!
adicionaNotamoderador: nota
	"Adiciona nota para esse conteudo"
	
	listaDeNotasModerador add: nota! !

!Conteudo methodsFor: 'primitivas' stamp: 'FA 5/12/2013 16:48'!
devolveTexto
	^ texto ! !

!Conteudo methodsFor: 'primitivas' stamp: 'FA 5/12/2013 17:18'!
initialize
	listaDeNotas := Set new.
	listaDeNotasModerador := Set new.
	^self! !

!Conteudo methodsFor: 'primitivas' stamp: 'tgn 5/12/2013 17:14'!
mediaDasNotas
	"Adiciona nota para esse conteudo"
	
	| total |
	total := 0.
	listaDeNotas do: [ :conteudo | total := total + conteudo. ].
	^ total / listaDeNotas size.! !

!Conteudo methodsFor: 'primitivas' stamp: 'tgn 5/12/2013 17:14'!
mediaDasNotasModerador
	"Adiciona nota para esse conteudo"
	
	| total |
	total := 0.
	listaDeNotasModerador do: [ :conteudo | total := total + conteudo. ].
	^ total / listaDeNotasModerador size.! !

!Conteudo methodsFor: 'primitivas' stamp: 'FA 5/12/2013 16:48'!
salvaTexto: string
	^ texto := string! !

Object subclass: #Sistema
	instanceVariableNames: 'admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Sistema commentStamp: 'tgn 5/11/2013 15:59' prior: 0!
Classe de acesso ao sistema!

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 15:57'!
acessarComNome: nomeAdmin eSenha: senhaAdmin
	"Tenta acessar o sistema"

	('admin' compare: nomeAdmin) = 2
		ifTrue: [ ^ ('admin' compare: senhaAdmin) = 2 ]
		ifFalse: [ ^ false ].
					
		! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:32'!
adicionaAluno: aluno naTurma: turma! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:31'!
adicionaConteudo: conteudo naAula: aula! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:28'!
adicionarModerador: moderador noCurso: curso! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:34'!
avaliarConteudo: conteudo peloUsuario: usuario comNota:nota! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:31'!
criarAulaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores naDisciplina: disciplina! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:28'!
criarCursoComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:28'!
criarDisciplinaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores noCurso: curso! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:31'!
criarTurmaComNome: nome Descricao: descricao Responsavel: responsavel Moderadores: moderadores naDisciplina: disciplina! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:29'!
criarUsuario: nome comSenha: senha eLogin: login! !

!Sistema methodsFor: 'initialize-release' stamp: 'tgn 5/12/2013 17:36'!
initialize

	admin := Admin new.! !

!Sistema methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:30'!
usuario: nome agoraModeraOTopico: topico! !

Object subclass: #Topico
	instanceVariableNames: 'nome dataDeCriacao descricao responsavel moderadores'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Topico commentStamp: 'HGPL 5/11/2013 15:49' prior: 0!
Classe base para elementos do sistema!

Topico subclass: #Aula
	instanceVariableNames: 'materiais'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Aula commentStamp: 'HGPL 5/11/2013 16:05' prior: 0!
Uma Aula do sistema!

Topico subclass: #Curso
	instanceVariableNames: 'disciplinas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Curso commentStamp: 'HGPL 5/11/2013 16:01' prior: 0!
Um Curso do sistema.!

!Curso methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:58'!
adicionaDisciplina: umaDisciplina
	"Adiciona uma disciplina ao curso"! !

!Curso methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
disciplinas
	"Answer the value of disciplinas"

	^ disciplinas! !

!Curso methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:58'!
removeDisciplina: umaDisciplina
	"Remove uma disciplina do curso"! !

Topico subclass: #Disciplina
	instanceVariableNames: 'aulas turmas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Disciplina commentStamp: 'HGPL 5/11/2013 16:03' prior: 0!
Uma Disciplina do sistema!

!Topico methodsFor: 'primitivas' stamp: 'HGPL 5/11/2013 17:49'!
adicionaModerador: umModerador
	"Adiciona um moderador ao Tpico"

	^ moderadores add: umModerador! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
dataDeCriacao
	"Answer the value of dataDeCriacao"

	^ dataDeCriacao! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
dataDeCriacao: anObject
	"Set the value of dataDeCriacao"

	dataDeCriacao := anObject! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
descricao
	"Answer the value of descricao"

	^ descricao! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
descricao: anObject
	"Set the value of descricao"

	descricao := anObject! !

!Topico methodsFor: 'primitivas' stamp: 'HGPL 5/11/2013 17:44'!
eModerador: umUsuario
	"Verifica se um usurio  um moderador nesse tpico"

	^ moderadores includes: umUsuario! !

!Topico methodsFor: 'inicializando' stamp: 'FA 5/12/2013 17:42'!
initialize
	"Inicializa o Tpico"

	nome := 'Tpico sem-nome'.
	dataDeCriacao := DateAndTime now.
	moderadores := Set new! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
moderadores
	"Answer the value of moderadores"

	^ moderadores! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
nome
	"Answer the value of nome"

	^ nome! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
nome: anObject
	"Set the value of nome"

	nome := anObject! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:54'!
responsavel
	"Answer the value of responsavel"

	^ responsavel! !

!Topico methodsFor: 'acessando' stamp: 'HGPL 5/11/2013 16:56'!
responsavel: anObject
	"Set the value of responsavel"

	responsavel := anObject! !

Topico subclass: #Turma
	instanceVariableNames: 'alunos instrutor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Turma commentStamp: 'HGPL 5/11/2013 16:06' prior: 0!
Uma turma do sistema!

Object subclass: #Usuario
	instanceVariableNames: 'nome login senha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Usuario commentStamp: 'tgn 5/11/2013 15:15' prior: 0!
Classe de usuario!

Usuario subclass: #Admin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Admin commentStamp: 'tgn 5/11/2013 17:15' prior: 0!
Classe de administrador.!

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:42'!
criarConteudo: infoConteudo
	"cria um conteudo generico"
	
	| novoConteudo |
	
	novoConteudo := Conteudo new.
	novoConteudo salvaTexto: infoConteudo.
	^ novoConteudo.! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/12/2013 17:43'!
criarTopico: nomeTopico comDescricao: descricao

	| topico |
	
	topico := Topico new.
	topico init.
	topico nome: nomeTopico.
	topico descricao: descricao.
	^ topico.! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/11/2013 17:26'!
criarUsuarioComNome: nomeNovo eSenha: senhaNovo eLogin: loginNovo
	"cria um conteudo generico"
	
	| usuario |
	usuario := Usuario new.
	^ usuario inicializaUsuarioComNome: nomeNovo eSenha: senhaNovo eLogin: loginNovo.! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/11/2013 17:22'!
deletaConteudo: conteudoASerDeletado
	"deleta um conteudo generico"! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/11/2013 17:29'!
deletaTopico: topico! !

!Admin methodsFor: 'system primitives' stamp: 'tgn 5/11/2013 17:28'!
deletarUsuarioComLogin: loginDoDeletado
	"Deleta um usuario"! !

!Admin methodsFor: 'initialize-release' stamp: 'tgn 5/12/2013 17:37'!
initialize

	login := 'admin'.
	senha := 'admin'.
	nome := 'admin'.! !

Usuario subclass: #Moderador
	instanceVariableNames: 'topicosQueModera'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poo'!

!Moderador commentStamp: 'tgn 5/11/2013 16:20' prior: 0!
Classe do moderador!

!Moderador methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 16:36'!
adicionaNovoTopico: topico
	"Adiciona novo topico para ser moderado"

	topicosQueModera add: topico.! !

!Moderador methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:06'!
deletaConteudo: conteudoASerDeletado
	"Adiciona novo topico para ser moderado"

! !

!Moderador methodsFor: 'inicializando' stamp: 'FA 5/12/2013 17:42'!
initialize
	"Inicia a Classe"

	topicosQueModera := Set new.! !

!Moderador methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:01'!
verificaSeModeraOTopico: topico
	"Verifica se esse moderador modera o topico passado"

	^ topicosQueModera includes: topico.! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:11'!
avaliaConteudo: conteudoASerAvaliado notaDada: notaDada
	"Adiciona novo topico para ser moderado"
! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:11'!
consultarConteudo: conteudoASerConsultado
	"Adiciona novo topico para ser moderado"
! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:14'!
criarConteudo: infoDoConteudo
	"Cria um novo conteudo"! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:13'!
delegarPoderAoUsuario: usuario noTopico: topico
	"Inseri usuario com poder de moderador no topico alvo"! !

!Usuario methodsFor: 'inicializando' stamp: 'tgn 5/11/2013 17:25'!
inicializaUsuarioComNome: novoNome eSenha: novaSenha eLogin: novoLogin
	"comment stating purpose of message"

	nome := novoNome.
	senha := novaSenha.
	login := novoLogin.
	! !

!Usuario methodsFor: 'primitivas' stamp: 'tgn 5/11/2013 17:12'!
inserirInformacoes: informacoes noTopico: topico
	"Inseri informacoes no topico alvo"! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:34'!
login
	"login"

	^ login! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:34'!
login: novoLogin
	"login"

	login := novoLogin! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:31'!
nome
	"nome"

	^ nome! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:33'!
nome: novoNome
	"nome"

	nome := novoNome! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:34'!
senha
	"senha"

	^ senha! !

!Usuario methodsFor: 'acessando' stamp: 'tgn 5/11/2013 15:34'!
senha: novaSenha
	"senha"

	senha := novaSenha! !
